#-----------------------------------------------------------------------------
# Set Range linear or spline
# if current actor is BODY, sets entire figure.
# Otherwise sets only current actor or prop.
# By Ockham (David G. Drumright)  5/23/08
#-----------------------------------------------------------------------------

from Tkinter import *
import poser
import string
import os
scene = poser.Scene()

#-----------------------------------------------------------------------------
# Next section is TK
#------------------------------------------------------------

class App:
	def __init__(self, master, textMessage):
		self.master = master
		master.title("Current actor or figure Lin or Spl")

		# Go/nogo buttons.
		self.buttonLinBef = Button(self.master, text="Linear Before", command=self.HandleLinBef)
		self.buttonLinBef.grid(row=0, column=0,pady=2,padx=2)
		self.buttonLinBef = Button(self.master, text="Linear All",    command=self.HandleLinAll)
		self.buttonLinBef.grid(row=0, column=1,pady=2,padx=2)
		self.buttonLinAft = Button(self.master, text="Linear After",  command=self.HandleLinAft)
		self.buttonLinAft.grid(row=0, column=2,pady=2,padx=2)
		self.buttonSplBef = Button(self.master, text="Spline Before", command=self.HandleSplBef)
		self.buttonSplBef.grid(row=1, column=0,pady=2,padx=2)
		self.buttonSplBef = Button(self.master, text="Spline All",    command=self.HandleSplAll)
		self.buttonSplBef.grid(row=1, column=1,pady=2,padx=2)
		self.buttonSplAft = Button(self.master, text="Spline After",  command=self.HandleSplAft)
		self.buttonSplAft.grid(row=1, column=2,pady=2,padx=2)

		self.master.protocol('WM_DELETE_WINDOW', self.HandleCancel)


	# - - - - - - - - - - - - - - - - - -

	def HandleLinBef(self):
		A=scene.CurrentActor()
		if string.upper(A.Name())=='BODY':
			F=A.ItsFigure()
			for subA in F.Actors():
				subA.SetRangeLinear(0,scene.Frame())
		else:
			A.SetRangeLinear(0,scene.Frame())

	# - - - - - - - - - - - - - - - - - -
	def HandleLinAll(self):
		A=scene.CurrentActor()
		if string.upper(A.Name())=='BODY':
			F=A.ItsFigure()
			for subA in F.Actors():
				subA.SetRangeLinear(0,(scene.NumFrames()+1))
		else:
			A.SetRangeLinear(0,(scene.NumFrames()+1))

	# - - - - - - - - - - - - - - - - - -

	def HandleLinAft(self):
		A=scene.CurrentActor()
		if string.upper(A.Name())=='BODY':
			F=A.ItsFigure()
			for subA in F.Actors():
				subA.SetRangeLinear(scene.Frame(),(scene.NumFrames()+1))
		else:
			A.SetRangeLinear(scene.Frame(),(scene.NumFrames()+1))

	# - - - - - - - - - - - - - - - - - -

	def HandleSplBef(self):
		A=scene.CurrentActor()
		if string.upper(A.Name())=='BODY':
			F=A.ItsFigure()
			for subA in F.Actors():
				subA.SetRangeSpline(0,scene.Frame())
		else:
			A.SetRangeSpline(0,scene.Frame())

	# - - - - - - - - - - - - - - - - - -

	def HandleSplAll(self):
		A=scene.CurrentActor()
		if string.upper(A.Name())=='BODY':
			F=A.ItsFigure()
			for subA in F.Actors():
				subA.SetRangeSpline(0,(scene.NumFrames()+1))
		else:
			A.SetRangeSpline(0,(scene.NumFrames()+1))

	# - - - - - - - - - - - - - - - - - -

	def HandleSplAft(self):
		A=scene.CurrentActor()
		if string.upper(A.Name())=='BODY':
			F=A.ItsFigure()
			for subA in F.Actors():
				subA.SetRangeSpline(scene.Frame(),(scene.NumFrames()+1))
		else:
			A.SetRangeSpline(scene.Frame(),(scene.NumFrames()+1))

	# - - - - - - - - - - - - - - - - - -

	def Update(self):
		if scene: scene.ProcessSomeEvents()
		root.lift()
		root.after(100, self.Update)

	# - - - - - - - - - - - - - - - - - -

	def HandleCancel(self):
		self.master.destroy()

#------------------------------------------------------------
# Activate the loop
#------------------------------------------------------------

root = Tk()
app = App(root, '')
app.Update()
root.mainloop()

#------------------------------------------------------------
# End TK loop.
#-----------------------------------------------------------------------------
